<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/DeclarationSorter.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/DeclarationSorter.py</title>
<link href="../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/DeclarationSorter.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2007 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno">  7</span>
<a id="line8"></a><span class="lineno">  8</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> Parametrized, Parameter</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line10"></a><span class="lineno"> 10</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-comment"># The names of the access specifiers</span></span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line">_access_specs = {ASG.DEFAULT: <span class="py-string">''</span>,</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line">                 ASG.PUBLIC: <span class="py-string">'Public '</span>,</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line">                 ASG.PROTECTED: <span class="py-string">'Protected '</span>,</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line">                 ASG.PRIVATE: <span class="py-string">'Private '</span>}</span>
<a id="line16"></a><span class="lineno"> 16</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line"><span class="py-comment"># The predefined order for section names</span></span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line">_section_order = (<span class="py-string">'Packages'</span>,</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line">                  <span class="py-string">'Modules'</span>,</span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line">                  <span class="py-string">'Namespaces'</span>,</span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line">                  <span class="py-string">'Macros'</span>,</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">                  <span class="py-string">'Class templates'</span>,</span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line">                  <span class="py-string">'Classes'</span>,</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line">                  <span class="py-string">'Interfaces'</span>,</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line">                  <span class="py-string">'Typedefs'</span>,</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">                  <span class="py-string">'Structs'</span>,</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">                  <span class="py-string">'Enums'</span>,</span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line">                  <span class="py-string">'Unions'</span>,</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">                  <span class="py-string">'Member function templates'</span>,</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">                  <span class="py-string">'Member functions'</span>,</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">                  <span class="py-string">'Function templates'</span>,</span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">                  <span class="py-string">'Functions'</span>)</span>
<a id="line33"></a><span class="lineno"> 33</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line"><span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/DeclarationSorter.html#_compare">_compare</a>(a, b):</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Compare two section names.&quot;&quot;&quot;</span></span>
<a id="line36"></a><span class="lineno"> 36</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">    ai, bi = 0, 0</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">    an, bn = a, b</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">    <span class="py-keyword">for</span> i <span class="py-keyword">in</span> range(1,4):</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">        access = _access_specs[i]</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">        len_access = len(access)</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">        is_a = (a[:len_access] == access)</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">        is_b = (b[:len_access] == access)</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">        <span class="py-keyword">if</span> is_a:</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">            <span class="py-keyword">if</span> <span class="py-keyword">not</span> is_b: <span class="py-keyword">return</span> -1 <span class="py-comment"># a before b</span></span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">            <span class="py-comment"># Both matched</span></span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">            an = a[len_access:]</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">            bn = b[len_access:]</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">            <span class="py-keyword">break</span></span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">        <span class="py-keyword">if</span> is_b:</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">            <span class="py-keyword">return</span> 1 <span class="py-comment"># b before a</span></span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">        <span class="py-comment"># Neither matched</span></span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">    <span class="py-comment"># Same access, sort by predefined order </span></span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">    <span class="py-keyword">for</span> section <span class="py-keyword">in</span> _section_order:</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">        <span class="py-keyword">if</span> an == section: <span class="py-keyword">return</span> -1 <span class="py-comment"># a before b</span></span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">        <span class="py-keyword">if</span> bn == section: <span class="py-keyword">return</span> 1 <span class="py-comment"># b before a</span></span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">    <span class="py-keyword">return</span> 0</span>
<a id="line58"></a><span class="lineno"> 58</span>
<a id="line59"></a><span class="lineno"> 59</span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/DeclarationSorter/DeclarationSorter.html">DeclarationSorter</a>(Parametrized, ASG.Visitor):</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Sort declarations by type and accessibility.&quot;&quot;&quot;</span></span>
<a id="line62"></a><span class="lineno"> 62</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">    struct_as_class = Parameter(False, <span class="py-string">'Fuse structs and classes into the same section.'</span>)</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">    group_as_section = Parameter(True, <span class="py-string">'Map group to section, instead of keeping it as a single declaration.'</span>)</span>
<a id="line65"></a><span class="lineno"> 65</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/DeclarationSorter/DeclarationSorter.html#__init__">__init__</a>(self, declarations = None, **args):</span>
<a id="line67"></a><span class="lineno"> 67</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">        super(DeclarationSorter, self).__init__(**args)</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">        self.__sections = {}</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">        self.__sorted_keys = []</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> declarations: <span class="py-comment"># This is a prototype</span></span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">            <span class="py-keyword">return</span></span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">        <span class="py-keyword">for</span> d <span class="py-keyword">in</span> declarations:</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">            d.accept(self)</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">        self.__sorted_keys = self.__sections.keys()</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">        self.__sorted_keys.sort(_compare)</span>
<a id="line77"></a><span class="lineno"> 77</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/DeclarationSorter/DeclarationSorter.html#__iter__">__iter__</a>(self): <span class="py-keyword">return</span> iter(self.__sorted_keys)</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/DeclarationSorter/DeclarationSorter.html#__getitem__">__getitem__</a>(self, i): <span class="py-keyword">return</span> self.__sections[i]</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/DeclarationSorter/DeclarationSorter.html#get">get</a>(self, *args): <span class="py-keyword">return</span> self.__sections.get(*args)</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/DeclarationSorter/DeclarationSorter.html#has_key">has_key</a>(self, k): <span class="py-keyword">return</span> self.__sections.haskey(k)</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/DeclarationSorter/DeclarationSorter.html#keys">keys</a>(self): <span class="py-keyword">return</span> self.__sorted_keys</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/DeclarationSorter/DeclarationSorter.html#values">values</a>(self): <span class="py-keyword">return</span> self.__sections.values()</span>
<a id="line84"></a><span class="lineno"> 84</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/DeclarationSorter/DeclarationSorter.html#_section_of">_section_of</a>(self, decl, name = None):</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Generate a section name for the given declaration.&quot;&quot;&quot;</span></span>
<a id="line87"></a><span class="lineno"> 87</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">        section = name <span class="py-keyword">or</span> decl.type.capitalize()</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">        <span class="py-keyword">if</span> self.struct_as_class <span class="py-keyword">and</span> section == <span class="py-string">'Struct'</span>:</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">            section = <span class="py-string">'Class'</span></span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">        <span class="py-keyword">if</span> section[-1] == <span class="py-string">'s'</span>: section += <span class="py-string">'es'</span></span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">        <span class="py-keyword">else</span>: section += <span class="py-string">'s'</span></span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">        <span class="py-keyword">if</span> decl.accessibility != ASG.DEFAULT:</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">            section = _access_specs[decl.accessibility] + section</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">        <span class="py-keyword">return</span> section</span>
<a id="line96"></a><span class="lineno"> 96</span>
<a id="line97"></a><span class="lineno"> 97</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/DeclarationSorter/DeclarationSorter.html#_add_declaration">_add_declaration</a>(self, decl, section):</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">        <span class="py-string">&quot;Adds the given declaration with given name and section.&quot;</span></span>
<a id="line100"></a><span class="lineno">100</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">        <span class="py-keyword">if</span> section <span class="py-keyword">not</span> <span class="py-keyword">in</span> self.__sections:</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">            self.__sections[section] = [decl]</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">            self.__sections[section].append(decl)</span>
<a id="line105"></a><span class="lineno">105</span>
<a id="line106"></a><span class="lineno">106</span>
<a id="line107"></a><span class="lineno">107</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/DeclarationSorter/DeclarationSorter.html#visit_declaration">visit_declaration</a>(self, decl):</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">        self._add_declaration(decl, self._section_of(decl))</span>
<a id="line109"></a><span class="lineno">109</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/DeclarationSorter/DeclarationSorter.html#visit_builtin">visit_builtin</a>(self, decl): <span class="py-keyword">pass</span></span>
<a id="line111"></a><span class="lineno">111</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/DeclarationSorter/DeclarationSorter.html#visit_macro">visit_macro</a>(self, decl):</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">        self._add_declaration(decl, self._section_of(decl, <span class="py-string">'Macro'</span>))</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/DeclarationSorter/DeclarationSorter.html#visit_forward">visit_forward</a>(self, decl):</span>
<a id="line114"></a><span class="lineno">114</span><span class="line">        <span class="py-keyword">if</span> decl.template:</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">            self.visit_class_template(decl)</span>
<a id="line116"></a><span class="lineno">116</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line117"></a><span class="lineno">117</span><span class="line">            self.visit_declaration(decl)</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/DeclarationSorter/DeclarationSorter.html#visit_group">visit_group</a>(self, group):</span>
<a id="line119"></a><span class="lineno">119</span><span class="line">        <span class="py-keyword">if</span> self.group_as_section:</span>
<a id="line120"></a><span class="lineno">120</span><span class="line">            section = group.name[-1]</span>
<a id="line121"></a><span class="lineno">121</span><span class="line">            <span class="py-keyword">for</span> d <span class="py-keyword">in</span> group.declarations:</span>
<a id="line122"></a><span class="lineno">122</span><span class="line">                self._add_declaration(d, section)</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line124"></a><span class="lineno">124</span><span class="line">            self.visit_declaration(group)</span>
<a id="line125"></a><span class="lineno">125</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/DeclarationSorter/DeclarationSorter.html#visit_scope">visit_scope</a>(self, decl):</span>
<a id="line126"></a><span class="lineno">126</span><span class="line">        self.visit_declaration(decl)</span>
<a id="line127"></a><span class="lineno">127</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/DeclarationSorter/DeclarationSorter.html#visit_class_template">visit_class_template</a>(self, decl):</span>
<a id="line128"></a><span class="lineno">128</span><span class="line">        self._add_declaration(decl, self._section_of(decl, <span class="py-string">'Class template'</span>))</span>
<a id="line129"></a><span class="lineno">129</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/DeclarationSorter/DeclarationSorter.html#visit_function">visit_function</a>(self, decl):</span>
<a id="line130"></a><span class="lineno">130</span><span class="line">        self.visit_declaration(decl)</span>
<a id="line131"></a><span class="lineno">131</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/DeclarationSorter/DeclarationSorter.html#visit_function_template">visit_function_template</a>(self, decl):</span>
<a id="line132"></a><span class="lineno">132</span><span class="line">        self._add_declaration(decl, self._section_of(decl, <span class="py-string">'Function template'</span>))</span>
<a id="line133"></a><span class="lineno">133</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:13 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
